#pragma once

#pragma warning(push, 3)
#include <windows.h>
#include <objbase.h>
#pragma warning(pop)
#pragma warning(disable: 4514) // unreferenced inline/local function removed


class CTasksExt : public IContextMenu, IObjectWithSite
{   

public:	
    // constructors
	CTasksExt();

	// destructor	
    ~CTasksExt();

	// IUnknown methods
	STDMETHOD (QueryInterface) (REFIID riid, LPVOID *ppv);
	STDMETHOD_(ULONG, AddRef)  (void);
	STDMETHOD_(ULONG, Release) (void);

	// IContextMenu methods
	STDMETHOD (GetCommandString) (UINT idCmd, UINT uFlags, UINT *pwReserved, LPSTR pszName, UINT cchMax);
	STDMETHOD (InvokeCommand)  (LPCMINVOKECOMMANDINFO pici);
	STDMETHOD (QueryContextMenu) (HMENU hmenu, UINT indexMenu, UINT idCmdFirst, UINT idCmdLast, UINT uFlags);

	// IObjectWithSite methods
	STDMETHOD (GetSite) (REFIID riid, void **ppvSite);
	STDMETHOD (SetSite) (IUnknown *pUnkSite);

	// CTasksExt methods
	// None

protected:
	ULONG    m_cRef;            // reference count
	IUnknown *m_punkSite;       // site (owner) pointer

};

