// CLSFACT.H - class definition for CTasksExtClassFactory

#pragma once

#pragma warning(push, 3)
#include <windows.h>
#include <objbase.h>
#pragma warning(pop)
#pragma warning(disable: 4514) // unreferenced inline/local function removed
#pragma warning(disable: 4710) // function not inlined


class CTasksExtClassFactory : public IClassFactory
{

public:
	// constructors
	CTasksExtClassFactory();

	// destructor
	~CTasksExtClassFactory();

	// IUnknown methods
	STDMETHOD (QueryInterface) (REFIID riid, LPVOID *ppv);
	STDMETHOD_(ULONG, AddRef)  (void);
	STDMETHOD_(ULONG, Release) (void);

	// IClassFactory methods
	STDMETHOD (CreateInstance) (LPUNKNOWN punkOuter, REFIID riid, LPVOID *ppvObj);
	STDMETHOD (LockServer)     (BOOL fLock);

protected:
	ULONG m_cRef;

};

